roles ['monitoring_role']

external_url '{{ external_url_sanitised }}'

# Prometheus
prometheus['listen_address'] = '0.0.0.0:9090'
prometheus['monitor_kubernetes'] = false

prometheus['flags'] = {
   'storage.tsdb.retention.time' => "{{ prometheus_data_retention_period }}",
}

prometheus['scrape_configs'] = [
  {
    'job_name': 'non_omnibus_node',
    'static_configs' => [
      'targets' => [
{% if 'haproxy_external' in groups %}
        "{{ haproxy_external_int_ip }}:9100",
{% endif %}
{% if 'haproxy_internal' in groups %}
        "{{ haproxy_internal_int_ip }}:9100",
{% endif %}
{% for ip in elastic_int_ips %}
        "{{ ip }}:9100",
{% endfor %}
        "{{ gitlab_nfs_int_ip }}:9100"
      ],
    ],
  },
  {
    'job_name': 'haproxy',
    'static_configs' => [
      'targets' => [
{% if 'haproxy_external' in groups %}
        "{{ haproxy_external_int_ip }}:1936",
{% endif %}
{% if 'haproxy_internal' in groups %}
        "{{ haproxy_internal_int_ip }}:1936"
{% endif %}
      ],
    ],
  },
{% if 'pgbouncer' in groups %}
  {
    'job_name': 'pgbouncer',
    'static_configs' => [
      'targets' => [
{% for ip in pgbouncer_int_ips %}
        "{{ ip }}:9188",
{% endfor %}
      ],
    ],
  },
{% endif %}
{% if 'praefect' in groups %}
  {
    'job_name': 'praefect',
    'static_configs' => [
      'targets' => [
{% for ip in praefect_int_ips %}
        "{{ ip }}:9652",
{% endfor %}
      ],
    ],
  },
{% endif %}
  {{ monitor_custom_prometheus_scrape_config }}
]

# Grafana
{% if grafana_password is defined and grafana_password != '' %}
grafana['admin_password'] = "{{ grafana_password | regex_escape() }}"
{% endif %}
grafana['disable_login_form'] = false
grafana['env'] = {
  'GF_AUTH_ANONYMOUS_ENABLED' => true,
  'GF_SERVER_ROOT_URL' => '{{ external_url_sanitised }}/-/grafana'
}

grafana['dashboards'] = [
  {
    'name' => 'GitLab Omnibus',
    'orgId' => 1,
    'folder' => 'GitLab Omnibus',
    'type' => 'file',
    'disableDeletion' => true,
    'updateIntervalSeconds' => 600,
    'options' => {
      'path' => '/opt/gitlab/embedded/service/grafana-dashboards',
    }
  },
  {
    'name' => 'GitLab Environment Toolkit',
    'orgId' => 1,
    'folder' => 'GitLab Environment Toolkit',
    'type' => 'file',
    'disableDeletion' => true,
    'updateIntervalSeconds' => 600,
    'options' => {
      'path' => '/opt/GitLab Environment Toolkit/dashboards',
    }
  },
{% for item in monitor_custom_dashboards %}
  {
    'name' => '{{ item.display_name }}',
    'orgId' => 1,
    'folder' => '{{ item.display_name }}',
    'type' => 'file',
    'disableDeletion' => true,
    'updateIntervalSeconds' => 600,
    'options' => {
      'path' => '/opt/{{ item.display_name }}/dashboards',
    }
  },
{% endfor %}
]

grafana['datasources'] = [
  {
    'name' => 'GitLab Omnibus',
    'type' => 'prometheus',
    'access' => 'proxy',
    'url' => 'http://localhost:9090'
  }
]

# Consul
consul['enable'] = true
consul['configuration'] = {
  bind_addr: '{{ ansible_default_ipv4.address }}',
  retry_join: %w({{ (consul_int_ips if 'consul' in groups else gitlab_rails_int_ips) | join(' ') }})
}
consul['monitoring_service_discovery'] = true

# Nginx
nginx['enable'] = true
nginx['status']['options'] = {
  "server_tokens" => "off",
  "access_log" => "off",
  "allow" => "{{ monitor_int_ip }}",
  "deny" => "all",
}

{% if external_url_ssl %}
nginx['listen_port'] = 80
nginx['listen_https'] = false

letsencrypt['enable'] = false
{% endif %}

node_exporter['listen_address'] = '0.0.0.0:9100'

custom_confs = Dir.glob(File.join("/etc/gitlab/", "gitlab.monitor.*.rb"))
custom_confs.each { |conf|
  from_file conf
}
